/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
if(void 0===AWS)throw new Error("AWS SDK must be loaded before loading the Sync Manager.");AWS.CognitoSyncManager=function(e){e=e||{};var t="CognitoJavaScriptSDK/1";this.provider=AWS.config.credentials,this.identityPoolId=this.provider.params.IdentityPoolId,this.region=AWS.config.region,this.logger=e.log,"function"!=typeof this.logger&&(this.logger=function(){}),this.local=new AWS.CognitoSyncManager.LocalStorage({DataStore:AWS.CognitoSyncManager.StoreLocalStorage}),this.remote=new AWS.CognitoSyncManager.RemoteStorage(this.identityPoolId,this.provider),this.remote.setUserAgent(t)},AWS.CognitoSyncManager.prototype.openOrCreateDataset=function(e,t){var n=this,a=new RegExp("^[a-zA-Z0-9_.:-]{1,128}$");a.test(e)?this.local.createDataset(this.getIdentityId(),e,function(e,a){return e?t(e,null):void t(null,new AWS.CognitoSyncManager.Dataset(a,n.provider,n.local,n.remote,n.logger))}):t(new Error("Dataset name must match the pattern "+a.toString()))},AWS.CognitoSyncManager.prototype.listDatasets=function(e){this.local.getDatasets(this.getIdentityId(),e)},AWS.CognitoSyncManager.prototype.refreshDatasetMetadata=function(e){var t=this;this.remote.getDatasets(function(n,a){var i=[],r=function(e){t.local.updateDatasetMetadata(t.getIdentityId(),e,s)},s=function(t,n){i.push(n),a.length>0?r(a.shift()):e(null,i)};a.length>0?r(a.shift(),e):e(null,[])})},AWS.CognitoSyncManager.prototype.wipeData=function(){this.provider.clearCachedId(),this.local.wipeData()},AWS.CognitoSyncManager.prototype.getIdentityId=function(){return this.provider.identityId},/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.Conflict=function(){var e=function(e,t){if(!e||!t)throw new Error("Remote and local records cannot be null.");if(!e.getKey||!t.getKey)throw new Error("Records are not record objects.");if(e.getKey()!==t.getKey())throw new Error("Remote and local keys do not match.");this.key=e.getKey(),this.remoteRecord=e,this.localRecord=t};return e.prototype.getKey=function(){return this.key},e.prototype.getRemoteRecord=function(){return this.remoteRecord},e.prototype.getLocalRecord=function(){return this.localRecord},e.prototype.resolveWithRemoteRecord=function(){return this.remoteRecord.setModified(!1),this.remoteRecord},e.prototype.resolveWithLocalRecord=function(){return this.localRecord.setSyncCount(this.remoteRecord.getSyncCount()),this.localRecord.setModified(!0),this.localRecord},e.prototype.resolveWithValue=function(e){return new AWS.CognitoSyncManager.Record({Key:this.remoteRecord.getKey(),Value:e,SyncCount:this.remoteRecord.getSyncCount(),LastModifiedDate:new Date,LastModifiedBy:this.localRecord.getLastModifiedBy(),DeviceLastModifiedDate:new Date,Modified:!0})},e}(),/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.Dataset=function(){var e=function(e,t,n,a,i){this.MAX_RETRY=3,this.datasetName=e,this.provider=t,this.local=n,this.remote=a,this.logger=i||function(){}};return e.prototype.validateKey=function(e){var t=new RegExp("^[a-zA-Z0-9_.:-]{1,128}$");return t.test(e)},e.prototype.put=function(e,t,n){return this.validateKey(e)?void this.local.putValue(this.getIdentityId(),this.datasetName,e,t,n):n(new Error("Invalid key."))},e.prototype.remove=function(e,t){return this.validateKey(e)?void this.local.putValue(this.getIdentityId(),this.datasetName,e,null,t):t(new Error("Invalid key."))},e.prototype.get=function(e,t){return this.validateKey(e)?void this.local.getValue(this.getIdentityId(),this.datasetName,e,t):t(new Error("Invalid key."))},e.prototype.getAllRecords=function(e){this.local.getRecords(this.getIdentityId(),this.datasetName,e)},e.prototype.getDataStorage=function(e){this.getDatasetMetadata(function(t,n){return t?e(t):n?e(null,n.getDataStorage()):e(null,0)})},e.prototype.isChanged=function(e,t){return this.validateKey(e)?void this.local.getRecord(this.getIdentityId(),this.datasetName,e,function(e,n){t(null,n&&n.isModified())}):t(new Error("Invalid key."))},e.prototype.getDatasetMetadata=function(e){this.local.getDatasetMetadata(this.getIdentityId(),this.datasetName,e)},e.prototype.resolve=function(e,t){this.local.putRecords(this.getIdentityId(),this.datasetName,e,t)},e.prototype.putAll=function(e,t){var n=!0;for(var a in e)e.hasOwnProperty(a)&&(this.validateKey(a)||(n=!1));return n?void this.local.putAllValues(this.getIdentityId(),this.datasetName,e,t):t(new Error("Object contains invalid keys."))},e.prototype.getAll=function(e){var t,n={};this.local.getRecords(this.getIdentityId(),this.datasetName,function(a,i){if(a)return e(a);for(var r in i)i.hasOwnProperty(r)&&(t=i[r],t.isDeleted()||(n[t.getKey()]=t.getValue()));e(null,n)})},e.prototype.getIdentityId=function(){return this.provider.identityId},e.prototype.getModifiedRecords=function(e){this.local.getModifiedRecords(this.getIdentityId(),this.datasetName,e)},e.prototype.getLocalMergedDatasets=function(e){var t,n=[],a=this.datasetName+".";this.local.getDatasets(this.getIdentityId(),function(i,r){for(var s in r)r.hasOwnProperty(s)&&(t=r[s],0===t.getDatasetName().indexOf(a)&&n.push(t.getDatasetName()));e(null,n)})},e.prototype.synchronize=function(e,t){var n=this;return e=e||{},e.onSuccess=e.onSuccess||function(){},e.onFailure=e.onFailure||function(){},e.onConflict=e.onConflict||function(e,t,n){return n(!1)},e.onDatasetDeleted=e.onDatasetDeleted||function(e,t,n){return n(!1)},e.onDatasetsMerged=e.onDatasetsMerged||function(e,t,n){return n(!1)},void 0===t&&(t=this.MAX_RETRY),n.logger("Starting synchronization... (retires: "+t+")"),0>t?e.onFailure(new Error("Synchronized failed: exceeded maximum retry count.")):void this.getLocalMergedDatasets(function(a,i){return a&&e.onFailure(a),n.logger("Checking for locally merged datasets... found "+i.length+"."),i.length>0?(n.logging("Deferring to .onDatasetsMerged."),e.onDatasetsMerged(n,i,function(a){return a?n.synchronize(e,--t):e.onFailure(new Error("Synchronization cancelled by onDatasetsMerged() callback returning false."))})):void n.local.getLastSyncCount(n.getIdentityId(),n.datasetName,function(a,i){return a?e.onFailure(a):(n.logger("Detecting last sync count... "+i),void n.remote.listUpdates(n.datasetName,i,function(a,r){if(a)return e.onFailure(a);n.logger("Fetch remote updates... found "+r.records.length+".");var s=r.getMergedDatasetNameList();if(n.logger("Checking for remote merged datasets... found "+s.length+"."),s.length>0)return n.logger("Deferring to .onDatasetsMerged."),e.onDatasetsMerged(n,s,function(a){a?n._synchronizeInternal(e,--t):e.onFailure(new Error("Cancelled due to .onDatasetsMerged result."))});if(0!==i&&!r||r.isDeleted())return e.onDatasetDeleted(n,r.getDatasetName(),function(a){return n.logging("Dataset should be deleted. Deferring to .onDatasetDeleted."),a?(n.logging(".onDatasetDeleted returned true, purging dataset locally."),n.local.purgeDataset(n.getIdentityId(),n.datasetName,function(a){return a?e.onFailure(a):n._synchronizeInternal(e,--t)})):(n.logging(".onDatasetDeleted returned false, cancelling sync."),e.onFailure(new Error("Cancelled due to .onDatasetDeleted result.")))});var o=r.getRecords(),l=r.getSyncCount(),d=r.getSyncSessionToken();n.logger("Checking for remote updates since last sync count... found "+o.length+"."),o.length>0?n._synchronizeResolveLocal(o,function(a,r){return a?e.onFailure(a):(n.logger("Checking for conflicts... found "+r.length+"."),void(r.length>0?(n.logger("Conflicts detected. Deferring to .onConflict."),e.onConflict(n,r,function(a){return a?void n._synchronizePushRemote(d,i,function(){return n.synchronize(e,--t)}):(n.logger(".onConflict returned false. Cancelling sync."),e.onFailure(new Error("Sync cancelled. Conflict callback returned false.")))})):(n.logger("No conflicts. Updating local records."),n.local.putRecords(n.getIdentityId(),n.datasetName,o,function(a){return a?e.onFailure(a):void n.local.updateLastSyncCount(n.getIdentityId(),n.datasetName,l,function(a){return a?e.onFailure(a):(n.logger("Finished resolving records. Restarting sync."),n.synchronize(e,--t))})}))))}):(n.logger("Nothing updated remotely. Pushing local changes to remote."),n._synchronizePushRemote(d,l,function(a){return a?(n.logger("Remote push failed. Likely concurrent sync conflict. Retrying..."),n.synchronize(e,--t)):(n.logger("Sync successful."),e.onSuccess(n,o))}))}))})})},e.prototype._synchronizeResolveLocal=function(e,t){var n=this,a=[];return e&&e.length>0?void n.local.getRecords(n.getIdentityId(),n.datasetName,function(i,r){var s,o,l,d={};for(s=0;s<r.length;s++)d[r[s].getKey()]=r[s];for(s=0;s<e.length;s++)o=e[s].getKey(),l=d[o],l&&l.isModified()&&l.getValue()!==e[s].getValue()?a.push(new AWS.CognitoSyncManager.Conflict(e[s],l)):l&&l.isModified()&&(l.setModified(!1),l.setSyncCount(e[s].getSyncCount()),n.local.store.set(n.getIdentityId(),n.datasetName,o,l.toJSON(),function(){}));return t(null,a)}):t(null,a)},e.prototype._synchronizePushRemote=function(e,t,n){var a=this;this.getModifiedRecords(function(t,i){return i.length>0?void a.remote.putRecords(a.datasetName,i,e,function(e,t){e&&n(e),a.local.putRecords(a.getIdentityId(),a.datasetName,t,function(e){if(e)return n(e);var i=0;for(var r in t)t.hasOwnProperty(r)&&(i=i<t[r].getSyncCount()?t[r].getSyncCount():i);a.local.updateLastSyncCount(a.getIdentityId(),a.datasetName,i,function(e){return e?n(e):n(null,!0)})})}):n(null,!0)})},e}(),/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.DatasetMetadata=function(){var e=function(e){if(e=e||{},this.datasetName=e.DatasetName||"",this.creationDate=new Date(e.CreationDate)||new Date,this.lastModifiedDate=new Date(e.LastModifiedDate)||new Date,this.lastModifiedBy=e.LastModifiedBy||"",this.dataStorage=e.DataStorage||0,this.recordCount=e.NumRecords||0,this.lastSyncCount=e.LastSyncCount||0,this.lastSyncDate=new Date(e.LastSyncDate||null)||new Date,this.dataStorage<0)throw new RangeError("Storage size cannot be negative.");if(this.recordCount<0)throw new RangeError("Record count cannot be negative.")};return e.prototype.getDatasetName=function(){return this.datasetName},e.prototype.setDatasetName=function(e){return this.datasetName=e,this},e.prototype.getCreationDate=function(){return this.creationDate},e.prototype.setCreationDate=function(e){return this.creationDate=new Date(e),this},e.prototype.getLastModifiedDate=function(){return this.lastModifiedDate},e.prototype.setLastModifiedDate=function(e){return this.lastModifiedDate=new Date(e),this},e.prototype.getLastModifiedBy=function(){return this.lastModifiedBy},e.prototype.setLastModifiedBy=function(e){return this.lastModifiedBy=e,this},e.prototype.getDataStorage=function(){return this.dataStorage},e.prototype.setDataStorage=function(e){return this.dataStorage=e,this},e.prototype.getRecordCount=function(){return this.recordCount},e.prototype.setRecordCount=function(e){return this.recordCount=e,this},e.prototype.getLastSyncCount=function(){return this.lastSyncCount},e.prototype.setLastSyncCount=function(e){return this.lastSyncCount=e,this},e.prototype.getLastSyncDate=function(){return this.lastSyncDate},e.prototype.setLastSyncDate=function(e){return this.lastSyncDate=e,this},e.prototype.toString=function(){return JSON.stringify(this.toJSON())},e.prototype.toJSON=function(){return{DatasetName:this.datasetName,CreationDate:this.creationDate,LastModifiedDate:this.lastModifiedDate,LastModifiedBy:this.lastModifiedBy,DataStorage:this.dataStorage,NumRecords:this.recordCount,LastSyncCount:this.lastSyncCount,LastSyncDate:this.lastSyncDate}},e}(),/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.DatasetUpdates=function(){var e=function(e){this.datasetName=e,this.records=[],this.syncCount=0,this.syncSessionToken="",this.exists=!0,this.deleted=!1,this.mergedDatasetNameList=[]};return e.prototype.getDatasetName=function(){return this.datasetName},e.prototype.setDatasetName=function(e){return this.datasetName=e,this},e.prototype.getRecords=function(){return this.records},e.prototype.addRecord=function(e){return this.records.push(e),this},e.prototype.getSyncCount=function(){return this.syncCount},e.prototype.setSyncCount=function(e){return this.syncCount=e,this},e.prototype.getSyncSessionToken=function(){return this.syncSessionToken},e.prototype.setSyncSessionToken=function(e){return this.syncSessionToken=e,this},e.prototype.isExists=function(){return this.exists},e.prototype.setExists=function(e){return this.exists=e,this},e.prototype.isDeleted=function(){return this.deleted},e.prototype.setDeleted=function(e){return this.deleted=e,this},e.prototype.getMergedDatasetNameList=function(){return this.mergedDatasetNameList},e.prototype.setMergedDatasetNameList=function(e){return this.mergedDatasetNameList=e,this},e}(),/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.LocalStorage=function(){var e=function(e){e=e||{},this.store=null,this.meta=null,this.store=e.DataStore?new e.DataStore:new AWS.CognitoSyncManager.StoreInMemory};return e.prototype.getMetadataKey=function(e,t){return e+"."+t},e.prototype.loadMetadataCache=function(e,t){var n=this;this.store.get("_internal","_metadata",e,function(e,a){return e?t(e,null):(a||(a={}),n.meta=a,void t(null,a))})},e.prototype.saveMetadataCache=function(e,t,n){this.store.set("_internal","_metadata",e,t,function(e){return e?n(e):n(null,t)})},e.prototype.createDataset=function(e,t,n){var a=this;return this.getDatasetMetadata(e,t,function(i,r){var s=(new Date).getTime();r?n(null,t):(r=new AWS.CognitoSyncManager.DatasetMetadata({DatasetName:t,CreationDate:s,LastModifiedDate:s}),a.setDatasetMetadata(e,t,r,function(){}),n(null,t))}),this},e.prototype.getDatasetMetadata=function(e,t,n){var a=this.getMetadataKey(e,t);return null!==this.meta?this.meta[a]?n(null,new AWS.CognitoSyncManager.DatasetMetadata(this.meta[a])):n(null,void 0):this.loadMetadataCache(e,function(e,t){t[a]?n(null,new AWS.CognitoSyncManager.DatasetMetadata(t[a])):n(null,void 0)}),this},e.prototype.setDatasetMetadata=function(e,t,n,a){return this.meta[this.getMetadataKey(e,t)]=n.toJSON(),this.saveMetadataCache(e,this.meta,a),this},e.prototype.getValue=function(e,t,n,a){this.getRecord(e,t,n,function(e,t){return t?a(null,t.getValue()):a(null,void 0)})},e.prototype.putValue=function(e,t,n,a,i){var r=this;this.getRecord(e,t,n,function(s,o){return o&&o.getValue()==a?i(null,o):(o||(o=new AWS.CognitoSyncManager.Record),o.setKey(n).setValue(a).setModified(!0).setSyncCount(o?o.getSyncCount():0).setDeviceLastModifiedDate(new Date),void r.store.set(e,t,n,o.toJSON(),function(n){return n?i(n):void r.updateLastModifiedTimestamp(e,t,function(e){return i(e,o)})}))})},e.prototype.getValueMap=function(e,t,n){var a,i={};this.getRecords(e,t,function(e,t){for(var r in t)t.hasOwnProperty(r)&&(a=t[r],a.isDeleted()||(i[a.getKey()]=a.getValue()));n(null,i)})},e.prototype.putAllValues=function(e,t,n,a){var i=this,r=[];for(var s in n)n.hasOwnProperty(s)&&r.push(s);var o=function(s){var l;return s?a(s):void(r.length>0?(l=r.shift(),i.putValue(e,t,l,n[l],function(){setTimeout(o,0)})):a(null,!0))};o(null,null)},e.prototype.getDatasets=function(e,t){var n=[];if(null!==this.meta){for(var a in this.meta)this.meta.hasOwnProperty(a)&&n.push(new AWS.CognitoSyncManager.DatasetMetadata(this.meta[a]));return t(null,n)}this.loadMetadataCache(e,function(e,a){for(var i in a)a.hasOwnProperty(i)&&n.push(new AWS.CognitoSyncManager.DatasetMetadata(a[i]));return t(null,n)})},e.prototype.updateDatasetMetadata=function(e,t,n){var a=this;this.getDatasetMetadata(e,t.getDatasetName(),function(i,r){i&&n(i),r||(r=new AWS.CognitoSyncManager.DatasetMetadata),r.setDatasetName(t.getDatasetName()).setCreationDate(t.getCreationDate()).setLastModifiedDate(t.getLastModifiedDate()).setLastModifiedBy(t.getLastModifiedBy()).setLastSyncCount(t.getLastSyncCount()).setRecordCount(t.getRecordCount()).setDataStorage(t.getDataStorage()),a.meta[a.getMetadataKey(e,t.getDatasetName())]=r.toJSON(),a.saveMetadataCache(e,a.meta,function(e){return e?n(e):n(null,r)})})},e.prototype.getRecord=function(e,t,n,a){this.store.get(e,t,n,function(e,t){return t?a(null,new AWS.CognitoSyncManager.Record(t)):a(new Error("Key doesn't exist."),null)})},e.prototype.getRecords=function(e,t,n){var a=[];this.store.getAll(e,t,function(e,t){for(var i in t)t.hasOwnProperty(i)&&a.push(new AWS.CognitoSyncManager.Record(t[i]));n(null,a)})},e.prototype.putRecords=function(e,t,n,a){var i=this;n=n||[];var r=function(){n.length>0&&i.updateAndClearRecord(e,t,n.shift(),function(e){return e?a(e):0===n.length?a(null,!0):void setTimeout(r,0)})};r()},e.prototype.deleteDataset=function(e,t,n){var a=this;this.store.removeAll(e,t,function(i){return i?n(i):void a.getDatasetMetadata(e,t,function(t,i){return t?n(t):(i.setLastModifiedDate(new Date),i.setSyncCount(-1),void a.updateDatasetMetadata(e,i,function(e){return e?n(e):n(null,!0)}))})})},e.prototype.purgeDataset=function(e,t,n){this.deleteDataset(e,t,function(a){a&&n(a),delete this.meta[t],this.saveMetadataCache(e,t,this.meta,function(e,t){n(null,t)})})},e.prototype.getLastSyncCount=function(e,t,n){this.getDatasetMetadata(e,t,function(e,t){return t?n(null,t.getLastSyncCount()):void n(new Error("Dataset doesn't exist."),null)})},e.prototype.getModifiedRecords=function(e,t,n){var a=[];this.getRecords(e,t,function(e,t){for(var i=0;i<t.length;i++)t[i].isModified()&&a.push(t[i]);n(null,a)})},e.prototype.updateLastSyncCount=function(e,t,n,a){var i=this;this.getDatasetMetadata(e,t,function(t,r){t&&a(t),r.setLastSyncCount(n).setLastSyncDate(new Date),i.updateDatasetMetadata(e,r,function(e){e&&a(e),a(null,!0)})})},e.prototype.wipeData=function(e){this.store.wipe(e)},e.prototype.updateLastModifiedTimestamp=function(e,t,n){var a=this;this.getDatasetMetadata(e,t,function(t,i){return t?n(t):(i.setLastModifiedDate(new Date),void a.updateDatasetMetadata(e,i,function(e){return e?n(e):n(null,!0)}))})},e.prototype.removeRecord=function(e,t,n){this.store.remove(e,t,n,function(e){return e?callback(e):callback(null,!0)})},e.prototype.updateAndClearRecord=function(e,t,n,a){this.store.set(e,t,n.getKey(),n.toJSON(),function(e){return e?a(e):a(null,!0)})},e}(),/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.Record=function(){var e=function(e){e=e||{},this.key=e.Key||"",this.value=e.Value||"",this.syncCount=e.SyncCount||0,this.lastModifiedDate=e.LastModifiedDate?new Date(e.LastModifiedDate):new Date,this.lastModifiedBy=e.LastModifiedBy||"",this.deviceLastModifiedDate=e.DeviceLastModifiedDate?new Date(e.DeviceLastModifiedDate):new Date,this.modified=e.Modified||!1};return e.prototype.getKey=function(){return this.key},e.prototype.setKey=function(e){return this.key=e,this},e.prototype.getValue=function(){return this.value},e.prototype.setValue=function(e){return this.value=e,this},e.prototype.getSyncCount=function(){return this.syncCount},e.prototype.setSyncCount=function(e){return this.syncCount=e,this},e.prototype.getLastModifiedDate=function(){return new Date(this.lastModifiedDate)},e.prototype.setLastModifiedDate=function(e){return this.lastModifiedDate=new Date(e),this},e.prototype.getLastModifiedBy=function(){return this.lastModifiedBy},e.prototype.setLastModifiedBy=function(e){return this.lastModifiedBy=e,this},e.prototype.getDeviceLastModifiedDate=function(){return new Date(this.deviceLastModifiedDate)},e.prototype.setDeviceLastModifiedDate=function(e){return this.deviceLastModifiedDate=new Date(e),this},e.prototype.isModified=function(){return this.modified},e.prototype.setModified=function(e){return this.modified=e,this},e.prototype.isDeleted=function(){return null===this.value},e.prototype.toString=function(){return JSON.stringify(this)},e.prototype.toJSON=function(){return{Key:this.key,Value:this.value,SyncCount:this.syncCount,LastModifiedDate:this.lastModifiedDate,LastModifiedBy:this.lastModifiedBy,DeviceLastModifiedDate:this.deviceLastModifiedDate,Modified:this.modified}},e}(),/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.RemoteStorage=function(){var e=function(e,t){this.identityPoolId=e,this.provider=t,this.client=new AWS.CognitoSync};return e.prototype.userAgent="",e.prototype.getIdentityId=function(){return this.provider.identityId},e.prototype.getDatasets=function(e){var t=this,n=[],a=null,i=function(e,n){t.client.listDatasets({IdentityId:t.getIdentityId(),IdentityPoolId:t.identityPoolId,MaxResults:64,NextToken:e},n)},r=function(t,s){for(var o=s.Datasets||[],l=0;l<o.length;l++)n.push(new AWS.CognitoSyncManager.DatasetMetadata(o[l]));a=s.NextToken,a?i(a,r):e(null,n)};i(a,r)},e.prototype.listUpdates=function(e,t,n){var a=this,i=null,r=new AWS.CognitoSyncManager.DatasetUpdates(e),s=function(n,i){a.client.listRecords({DatasetName:e,IdentityId:a.getIdentityId(),IdentityPoolId:a.identityPoolId,LastSyncCount:t,MaxResults:250,NextToken:n},i)},o=function(e,t){if(e)return n(e);t=t||{};for(var a,l=t.Records||[],d=0;d<l.length;d++)a=new AWS.CognitoSyncManager.Record(l[d]),a.setModified(!1),r.addRecord(a);r.setSyncSessionToken(t.SyncSessionToken).setSyncCount(t.DatasetSyncCount).setExists(t.DatasetExists).setDeleted(t.DatasetDeletedAfterRequestedSyncCount),t.MergedDatasetNames&&r.setMergedDatasetNameList(t.MergedDatasetNames),i=t.NextToken,i?s(i,o):n(null,r)};s(null,o)},e.prototype.putRecords=function(e,t,n,a){var i,r=this,s=[];for(var o in t)t.hasOwnProperty(o)&&(i=t[o],s.push({Key:i.getKey(),Op:i.getValue()?"replace":"remove",SyncCount:i.getSyncCount(),DeviceLastModifiedDate:i.getDeviceLastModifiedDate(),Value:i.getValue()}));this.client.updateRecords({DatasetName:e,IdentityId:r.getIdentityId(),IdentityPoolId:r.identityPoolId,SyncSessionToken:n,RecordPatches:s},function(t,n){var i="string"==typeof e?e:"(invalid dataset name)";if(t)return a(new Error("Failed to update records in dataset: "+i+" ("+t.message+")"),null);for(var r,s=[],o=0;o<n.Records.length;o++)r=new AWS.CognitoSyncManager.Record(n.Records[o]),r.setModified(!1),s.push(r);return a(null,s)})},e.prototype.deleteDataset=function(e,t){this.client.deleteDataset({DatasetName:e,IdentityId:this.getIdentityId(),IdentityPoolId:this.identityPoolId},function(e,n){return e?t(new Error("Failed to delete dataset."),null):t(null,n)})},e.prototype.getDatasetMetadata=function(e,t){this.client.describeDataset({DatasetName:e,IdentityId:this.getIdentityId(),IdentityPoolId:this.identityPoolId},function(e,n){return e?t(new Error("Failed to get dataset metadata."),null):t(null,new AWS.CognitoSyncManager.DatasetMetadata(n.Dataset))})},e.prototype.setUserAgent=function(e){this.userAgent=e},e}(),/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.StoreInMemory=function(){var e=function(){this.store={}};return e.prototype.makeKey=function(e,t){return e+"."+t},e.prototype.get=function(e,t,n,a){var i=this.makeKey(e,t);return e&&t?this.store[i]&&this.store[i][n]?a(null,this.store[i][n]):a(null,void 0):a(new Error("You must provide an identity id and dataset name."),null)},e.prototype.getAll=function(e,t,n){var a=this.makeKey(e,t);return e&&t?n(null,this.store[a]):n(new Error("You must provide an identity id and dataset name."),null)},e.prototype.set=function(e,t,n,a,i){var r=this.makeKey(e,t),s=this.store[r]||{};return s[n]=a,this.store[r]=s,i(null,s)},e.prototype.setAll=function(e,t,n,a){var i=this.makeKey(e,t);return this.store[i]=n,a(null,n)},e.prototype.remove=function(e,t,n,a){var i=this.makeKey(e,t),r=JSON.parse(this.store[i]);return r||(r={}),delete r[n],this.store[i]=JSON.stringify(r),a(null,!0)},e.prototype.removeAll=function(e,t,n){var a=this.makeKey(e,t);return delete this.store[a],n(null,!0)},e.prototype.wipe=function(e){return this.store={},e(null,!0)},e}(),/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.StoreLocalStorage=function(){var e=function(){this.store=AWS.CognitoSyncManager.localStorage||window.localStorage};return e.prototype.makeKey=function(e,t){return e+"."+t},e.prototype.get=function(e,t,n,a){var i=this.makeKey(e,t);if(!e||!t)return a(new Error("You must provide an identity id and dataset name."),null);var r=JSON.parse(this.store.getItem(i));return r&&r[n]?a(null,r[n]):a(null,void 0)},e.prototype.getAll=function(e,t,n){var a=this.makeKey(e,t);return e&&t?n(null,JSON.parse(this.store.getItem(a))):n(new Error("You must provide an identity id and dataset name."),null)},e.prototype.set=function(e,t,n,a,i){var r=this.makeKey(e,t),s=JSON.parse(this.store.getItem(r));return s||(s={}),s[n]=a,this.store.setItem(r,JSON.stringify(s)),i(null,s),this},e.prototype.setAll=function(e,t,n,a){var i=this.makeKey(e,t);return this.store.setItem(i,JSON.stringify(n)),a(null,n)},e.prototype.remove=function(e,t,n,a){var i=this.makeKey(e,t),r=JSON.parse(this.store.getItem(i));return r||(r={}),delete r[n],this.store.setItem(i,JSON.stringify(r)),a(null,!0)},e.prototype.removeAll=function(e,t,n){var a=this.makeKey(e,t);return this.store.removeItem(a),n(null,!0)},e.prototype.wipe=function(e){for(var t in this.store)this.store.hasOwnProperty(t)&&-1===t.indexOf("aws.cognito.identity")&&this.store.removeItem(t);return e?e(null,!0):this},e}();